#include <TinyGPSPlus.h>

TinyGPSPlus gps;

void sendUBX(uint8_t *MSG, uint8_t len)//передача пакета в модуль GPS
{
  Serial.flush();
  Serial.write(0xFF);
  delay(500);
  for (int i = 0; i < len; i++) {
    Serial.write(MSG[i]);
  }
}

boolean getUBX_ACK(uint8_t *MSG) //проверка, что всё правильно
{
  uint8_t b;
  uint8_t ackByteID = 0;
  uint8_t ackPacket[10];
  unsigned long startTime = millis();

  // Construct the expected ACK packet
  ackPacket[0] = 0xB5; // header
  ackPacket[1] = 0x62; // header
  ackPacket[2] = 0x05; // class
  ackPacket[3] = 0x01; // id
  ackPacket[4] = 0x02; // length
  ackPacket[5] = 0x00;
  ackPacket[6] = MSG[2]; // ACK class
  ackPacket[7] = MSG[3]; // ACK id
  ackPacket[8] = 0; // CK_A
  ackPacket[9] = 0; // CK_B

  // Calculate the checksums
  for (uint8_t ubxi = 2; ubxi < 8; ubxi++) {
    ackPacket[8] = ackPacket[8] + ackPacket[ubxi];
    ackPacket[9] = ackPacket[9] + ackPacket[8];
  }

  while (1) {

    // Test for success
    if (ackByteID > 9) {
      return true;
    }
    // Timeout if no valid response in 3 seconds
    if (millis() - startTime > 3000) {

      return false;
    }
    // Make sure data is available to read
    if (Serial.available()) {
      b = Serial.read();

      // Check that bytes arrive in sequence as per expected ACK packet
      if (b == ackPacket[ackByteID]) {
        ackByteID++;
      }
      else {
        ackByteID = 0; // Reset and look again, invalid order
      }
    }
  }
}

void gps_set_max_performance_mode() //утановка GPS в режим максимальной эффективности
{
  int gps_set_sucess = 0;
  uint8_t setMax[] = {
    0xB5, 0x62, 0x06, 0x11, 0x02, 0x00, 0x08, 0x00, 0x21, 0x91
  };
  sendUBX(setMax, sizeof(setMax) / sizeof(uint8_t));
  gps_set_sucess = getUBX_ACK(setMax);
  if (gps_set_sucess == 1) OzOled.printString("OK", 9, 0); //если всё нормально - пишем на дисплей ОК
  else OzOled.printString("NOT OK", 9, 0);//иначе - NOT OK
}

void setGPStime() // Установка времени
{
  if (gps.time.isValid())
  {
    Hour = gps.time.hour();
    Minute = gps.time.minute();
    Second = gps.time.second();
    setTime(Hour, Minute, Second, 1, 1, 2000); // (hr,min,sec,day,month,yr)
  }
}
